ru.bitel.bgbilling.kernel.tariff.option.common.service

## Interface TariffOptionService

-     public interface TariffOptionService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `contractTariffOptionActivate(int contractId, int optionId, int modeId, boolean web)` Активирование тарифной опции для договора.
    `int` | `contractTariffOptionActivateWhithSum(int contractId, int optionId, int modeId, java.math.BigDecimal chargeSum, boolean web)` Активирование тарифной опции для договора, с суммой расхода .
    `void` | `contractTariffOptionDeactivate(int contractId, int contractOptionId)` Деактивация тарифной опции.
    `void` | `contractTariffOptionDelete(int contractId, int id, boolean customer)`
    `java.util.List<ContractTariffOption>` | `contractTariffOptionHistory(int contractId, java.util.Date date, boolean web)` Получение списка тарифных опций договора, период действия которых закончился по отношении к указанной дате.
    `java.util.List<ContractTariffOption>` | `contractTariffOptionList(int contractId, java.util.Date date)` Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой.
    `java.util.List<ContractTariffOption>` | `contractTariffOptionListWeb(int contractId, java.util.Date date, java.util.List<ContractTariffOption> contractTariffOptionList)` Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой для web.
    `void` | `contractTariffOptionReactivate(int contractId, int contractOptionId)` Реактивация тарифной опции.
    `TariffOptionActivateMode` | `tariffOptionActivateModeGet(int optionId, int modeId)` Вернет режим активации.
    `java.util.List<TariffOptionActivateMode>` | `tariffOptionActivateModeList(int optionId, java.util.Date date)`
    `void` | `tariffOptionDelete(int id)` Удаление тарифной опции
    `TariffOption` | `tariffOptionGet(int id)` Получение тарифной опции по коду.
    `java.util.List<TariffOption>` | `tariffOptionList()` Получение списка всех тарифных опций.
    `java.util.List<TariffOption>` | `tariffOptionListAvailable(int contractId, java.util.Date date, java.util.List<ContractTariffOption> currentContractOptionList, boolean onlyAvailable, boolean web)` Получение списка тарифных опций на указанную дату, c заполнением поля enable c учетом тарифов и групп договоров.
    `void` | `tariffOptionUpdate(TariffOption tariffOption)` Обновление тарифной опции
    `java.util.List<TariffOption>` | `tariffOptionWebList(int contractId, java.util.Date date, java.util.List<TariffOption> fullOptionList)` Опции, которые можно показывать в веб.

- - ### Method Detail

    - #### tariffOptionGet

          TariffOption tariffOptionGet(int id)
                                throws ru.bitel.bgbilling.common.BGException

      Получение тарифной опции по коду.
      Parameters:
        `id` - код тарифной опции
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionList

          java.util.List<TariffOption> tariffOptionList()
                                                 throws ru.bitel.bgbilling.common.BGException

      Получение списка всех тарифных опций.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionWebList

          java.util.List<TariffOption> tariffOptionWebList(int contractId,
                                                           java.util.Date date,
                                                           java.util.List<TariffOption> fullOptionList)
                                                    throws ru.bitel.bgbilling.common.BGException

      Опции, которые можно показывать в веб.
      Parameters:
        `contractId` -
        `date` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionListAvailable

          java.util.List<TariffOption> tariffOptionListAvailable(int contractId,
                                                                 java.util.Date date,
                                                                 java.util.List<ContractTariffOption> currentContractOptionList,
                                                                 boolean onlyAvailable,
                                                                 boolean web)
                                                          throws ru.bitel.bgbilling.common.BGException

      Получение списка тарифных опций на указанную дату, c заполнением поля enable c учетом тарифов и групп договоров.
      Parameters:
        `contractId` -
        `date` -
        `onlyAvailable` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionUpdate

          void tariffOptionUpdate(TariffOption tariffOption)
                           throws ru.bitel.bgbilling.common.BGException

      Обновление тарифной опции
      Parameters:
        `tariffOption` - опция
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionDelete

          void tariffOptionDelete(int id)
                           throws ru.bitel.bgbilling.common.BGException

      Удаление тарифной опции
      Parameters:
        `id` - код опции
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionActivateModeList

          java.util.List<TariffOptionActivateMode> tariffOptionActivateModeList(int optionId,
                                                                                java.util.Date date)
                                                                         throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffOptionActivateModeGet

          TariffOptionActivateMode tariffOptionActivateModeGet(int optionId,
                                                               int modeId)
                                                        throws ru.bitel.bgbilling.common.BGException

      Вернет режим активации.
      Parameters:
        `modeId` - ид режима активации тарифной опции.
        `optionId` - ид тарифной опции.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### contractTariffOptionList

          java.util.List<ContractTariffOption> contractTariffOptionList(int contractId,
                                                                        java.util.Date date)
                                                                 throws ru.bitel.bgbilling.common.BGException

      Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой.
      Т.е. активных тарифных опций.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### contractTariffOptionListWeb

          java.util.List<ContractTariffOption> contractTariffOptionListWeb(int contractId,
                                                                           java.util.Date date,
                                                                           java.util.List<ContractTariffOption> contractTariffOptionList)
                                                                    throws ru.bitel.bgbilling.common.BGException

      Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой для web.
      Т.е. активных тарифных опций.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### contractTariffOptionActivate

          void contractTariffOptionActivate(int contractId,
                                            int optionId,
                                            int modeId,
                                            boolean web)
                                     throws ru.bitel.bgbilling.common.BGException,
                                            ru.bitel.bgbilling.common.BGMessageException

      Активирование тарифной опции для договора.
      Parameters:
        `contractId` - договор
        `optionId` - опций
        `modeId` - режим активации опции
      Throws:
        `ru.bitel.bgbilling.common.BGException` - если активация невозможна или произошла ошибка
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffOptionActivateWhithSum

          int contractTariffOptionActivateWhithSum(int contractId,
                                                   int optionId,
                                                   int modeId,
                                                   java.math.BigDecimal chargeSum,
                                                   boolean web)
                                            throws ru.bitel.bgbilling.common.BGException,
                                                   ru.bitel.bgbilling.common.BGMessageException

      Активирование тарифной опции для договора, с суммой расхода .
      Parameters:
        `contractId` - договор
        `optionId` - опций
        `modeId` - режим активации опции
        `chargeSum` - сумма расхода
      Returns:
        ид расхода договора
      Throws:
        `ru.bitel.bgbilling.common.BGException` - если активация невозможна или произошла ошибка
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffOptionDeactivate

          void contractTariffOptionDeactivate(int contractId,
                                              int contractOptionId)
                                       throws ru.bitel.bgbilling.common.BGException,
                                              ru.bitel.bgbilling.common.BGMessageException

      Деактивация тарифной опции.
      Parameters:
        `contractId` - договор
        `contractOptionId` - код активированной тарифной опции
      Throws:
        `ru.bitel.bgbilling.common.BGException` - если деактивация невозможна или произошла ошибка
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffOptionReactivate

          void contractTariffOptionReactivate(int contractId,
                                              int contractOptionId)
                                       throws ru.bitel.bgbilling.common.BGException,
                                              ru.bitel.bgbilling.common.BGMessageException

      Реактивация тарифной опции.
      Parameters:
        `contractId` - договор
        `contractOptionId` - код деактивированной тарифной опции
      Throws:
        `ru.bitel.bgbilling.common.BGException` - если реактивация невозможна или произошла ошибка
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### contractTariffOptionHistory

          java.util.List<ContractTariffOption> contractTariffOptionHistory(int contractId,
                                                                           java.util.Date date,
                                                                           boolean web)
                                                                    throws ru.bitel.bgbilling.common.BGException

      Получение списка тарифных опций договора, период действия которых закончился по отношении к указанной дате.
      Parameters:
        `contractId` - договор
        `date` - дата
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### contractTariffOptionDelete

          void contractTariffOptionDelete(int contractId,
                                          int id,
                                          boolean customer)
                                   throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`